package experiment.event;

import experiment.event.capability.Directive;
import experiment.ExperimentState;

import walker.exceptions.badSyntaxException;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 11, 2010
 *
 * Implements the information for a a single change in the network
 */
public abstract class Event {

    protected double timestamp;

    /**
     * Abstract definition of a function that applies the event to the experiment.
     *
     * @param state The experiment State to apply the event.
     * @return true if event was successfully applied.
     * @throws walker.exceptions.badSyntaxException in case of a mistake in the wiseml syntax.
     */
    public abstract boolean apply(ExperimentState state) throws badSyntaxException;

    /**
     * @return the Event's timestamp
     */
    public double getTimestamp() {
        return timestamp;
    }

    public abstract void addData(Directive data);
}
