package experiment.property;

import experiment.Setup.*;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 10, 2010
 *
 * Utilizes objects that describe the wiseml rssi tag.
 * The user needs to specify the name, datatype, unit and a value.
 */
public class Rssi {

    private Datatype dtype;
    private Unit unit;
    private String value;

    public Rssi(Datatype dtype, Unit unit, String value) {
        this.dtype = dtype;
        this.unit = unit;
        this.value = value;
    }

    public Rssi(String value) {
		// TODO Auto-generated constructor stub
    	this.value = value;
	}

	/**
     * @return the rssi's datatype.
     */
    public Datatype getDtype() {
        return dtype;
    }

     /**
     * @return the rssi's Unit type.
     */
    public Unit getUnit() {
        return unit;
    }

     /**
     * @return the rssi's actual value.
     */
    public String getValue() {
        return value;
    }

    /**
     * Update's this Rssi's value with a new one. Type Compartibility is not checked, so the caller should make sure
     * to use this method correctly.
     *
     * @param value is the new value.
     */
    public void update(String value){
        this.value = value;
    }
}
