package walker;

import static walker.utilities.Output.print;

import java.io.*;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.util.zip.GZIPInputStream;

import visual.Crawler;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 23, 2010
 *
 * DEPRECATED!
 * A singleton class responsible for splitting the wiseml file and mapping each subfile to virtual memory.
 */
public class FileManipulator {

    public static final long SUB_FILE_SIZE = 1<<30;
    private long length = 0;
    private MappedByteBuffer[] input;
    private int pageNumber;
    private static FileManipulator instance;
    private static String fileName = Crawler.getFileName();

    /**
     * Default Private Constructor
     */
    private FileManipulator(){
        try {
            readPartFile(0,1000);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Returns an instance of this class. If the class has not yet been instantiated, it instantiates it first.
     *
     * @return the FileManipulator instance.
     */
    public static synchronized FileManipulator getInstance(){
        // If no filename is specified abort
        if (fileName.equals("")){
            System.out.println("Specify a fileName before getting a FileManipulator Instance");
            return null;

        // if this is the first time, instantiate it
        } else if (instance == null){
            instance = new FileManipulator();
        }
        
        return instance;
    }

    /**
     * Returns a byte buffer containing the requested subfile. The ByteBufferBackedInputStream can be
     * used as an InputStream.
     *
     * @param index the number of the requested subfile.
     * @return a byte buffer containing the requested subfile.
     */
    public ByteBufferBackedInputStream getBBBInputStream(int index){
        if (index < pageNumber){
            return new ByteBufferBackedInputStream(input[index]);
        }
		return null;
    }

    public GZIPInputStream getGZIPBBBInputStream(int index) throws IOException {
        if (index < pageNumber){
            return new GZIPInputStream(getBBBInputStream(index));
        }
		return null;
    }

    /**
	 * @param startPosition unused? 
     * @param endPosition unused?
	 */
    public void readPartFile(long startPosition, long endPosition) throws FileNotFoundException {

        File f = new File(fileName);
        print(length  = f.length());

        RandomAccessFile ram = new RandomAccessFile(fileName, "r");

    }
    /**
     * Reads a wiseml file and splits it to pageNumber number of mapped byte buffers.
     *
     * @throws java.io.IOException is thrown in case of io problems
     */
    public void readFile() throws java.io.IOException {

        File f = new File(fileName);
        length  = f.length();

        if (length>= (1L<< 38)){
            System.out.println("document too big > 256 Gbyte");
            return;
        }

        RandomAccessFile raf = new RandomAccessFile(fileName, "r");
        FileChannel fc  = raf.getChannel();
        pageNumber = (int)(length>>30)+(((length & 0x3fffffffL)==0)?0:1);

        System.out.println("(Mapper) Subfile Allocation size is 1GB");
        System.out.println("\n\n(Mapper) Input file of size (" + length/1048576f + "MB) is going to be split in " + pageNumber + " buffers");

        input = new MappedByteBuffer[pageNumber];
        long l2 = 0;

        for (int i=0;i<pageNumber;i++){
            if (length > (1<<30)){

                if (i<pageNumber-1){
                    System.out.println("(Mapper) Part " + i + " : (" + l2/1024l  + " KB) -> (" + (l2+(1<<30))/1024l + " KB)");
                    input[i]= fc.map(FileChannel.MapMode.READ_ONLY, l2, 1<<30);
                    l2 = l2+(1<<30);

                } else {
                    System.out.println("(Mapper) Part " + i + " : (" + l2/1024l  + " KB) -> (" + (length-l2)/1024l + " KB)");
                    input[i]= fc.map(FileChannel.MapMode.READ_ONLY, l2, length - l2);
                }
            }
            else{
                System.out.println("(Mapped) Mapping : from (" + l2/1024l  + ") -> (" + (length - (i<<30) + l2)/1024l + " KB)");
                input[i]= fc.map(FileChannel.MapMode.READ_ONLY, l2, length - (i<<30));
            }
        }

        if (fc!=null){
            fc.close();
        }

    }

    /**
     * @return the length of the wiseml file
     */
    public long getLength() {
        return length;
    }

    /**
     * @return the total number of subfiles;
     */
    public int getPageNumber() {
        return pageNumber;
    }
}
